; Matrix 1.4

; progamm par Christophe Molon-Noblot 12/2000
; ximoon@voila.fr
; mon premier programme assembleur qui marche !!
; a ne sert  rien mais a fait toujours plaisir d'arriver  quelque chose
; pour ti92 (seulement test sur ti92 2.1 avec Fargo II)
; assembl avec Fargo II (2.71.f2) de David Ellsworth
; a n'est pas sens planter (a ne m'est jamais arriv) mais attention: c'est toujours de l'assembleur alors...

; 100% de commentaires pour aider les chtits lutteurs comme moi ;o)

; comment a marche?
; avant tout on efface l'cran et on choisit la taille de police de caractre 1
; on a pour commencer une liste vide de 40 lments
; avec la taille de police de caractre 1 les caractres font 6 pixels de large et 8 de haut
; il y a donc 40 caractres par ligne et 16 lignes sur une ti92
; on teste la liste case par case
; si une case contient 32 (caractre de "space") elle est considre comme vide
; si elle contient autre chose on affiche le caractre dont le code est dans la liste  l'endroit considr
; en plus, s'il y a un caractre, il y a 1 chance sur 10 pour qu'on n'en mette plus
; de mme, s'il n'y en a pas, il y a 1 chance sur 20 pour qu'on en mette un
; quand on sait quel caractre afficher, on l'affiche sur la premire ligne de l'cran
; s'il n'y a aucun caractre, on affiche un espace
; on passe au caractre suivant et au bout de 40 fois on a une ligne entire
; on copie alors tout l'cran sauf la dernire ligne et on le recopie de la deuxime  la dernire ligne 
; tous les caractres sont donc descendus d'une ligne
; on teste alors si la touche [on] a t appuye, si oui on quitte
; sinon on recommence du dbut
; Pour la version 89, on change juste la taille de la liste.


calc equ 1		; 92+:1 89:2

 include "userlib.h"			; bibliothques de fonctions utilises par le programme
 include "DoorsOs.h"
 include "graphlib.h"

 xdef _main				; indispensable
 xdef _comment				; pour afficher un commentaire

 ifeq calc-1
 xdef	_ti92plus
line_len	equ	30
char_n	equ	40
height	equ	100
 endc

 ifeq calc-2
 xdef	_ti89
line_len	equ	20
char_n	equ	26
height	equ	92
 endc

_main:					; le programme commence ici
	clr.w	graphlib::choosescreen
	jsr	graphlib::clr_scr		; graphlib::clr_scr - efface l'cran

	move.w	#1,-(a7)		; empile la taille de la police ici taille moyenne de 6*8 pixels
	jsr	doorsos::FontSetSys		; tios::FontSetSys - choisit la taille des caractres

	addq	#2,a7			; restaure la pile de 2
	lea	liste,a6		; on charge l'adresse de la liste dans a6
 prc:

	ifne calc-2
	moveq	#40-1,d7		; il y a 40 caractres sur une ligne affichs ici de la droite vers la gauche
	endif
	ifeq calc-2
	moveq	#26-1,d7		; pour ti89
	endif


 prc1:

	move.b	0(a6,d7),d1		; on enregistre le contenu de la d7me valeur dans d1

	cmp.w	#32,d1			; y avait-il un caractre  la ligne prcdente?
	bne	nvide1			; oui goto nvide1

	moveq	#20-1,d0		; non alors une chance sur 20 pour en mettre un

	jsr	userlib::random		; flib::random - retourne un entier pseudo-alatoire

	tst.w	d0			; si random donne 0 alors on en met un, pour cela on va au label car1
	bne	ncar1			; sinon on va  ncar1

 car1:

	st	d0			; on dfini l'intervalle, ici [0,255]
	jsr	userlib::random		; flib::random - retourne un entier pseudo-alatoire

	move.w	d0,d5

 car3:
	move.w	d7,d2			; on effectue la boucle avec d7 alors il ne faut pas trop le modifier

	mulu.w	#6,d2			; les caractres ont 6 pixels de large

	pea	$000000FF		; l, c'est optimis...
	pea  	$000400FF		; couleur 4=noir sur blanc
	clr.w	-(a7)			; y premire ligne donc 0
	move.w	d2,-(a7)		; x
	move.w 	d5,-(a7)		; code du caractre

	jsr 	userlib::DrawCharXY		; DrawCharXY

	lea	14(a7),a7		; restaure la pile de 2+2+2+2+2+2+2=14

	move.b	d5,0(a6,d7)		; on enregistre d5 dans la d7me valeur de la liste

 ncar1:

	dbra	d7,prc1			; caractre suivant

	clr	d0			; x tout  gauche donc 0
	clr	d1			; y premire ligne donc 0

	moveq	#line_len,d2			; largeur en octets
	moveq	#height,d3			; hauteur en pixels
	jsr	graphlib::scrtomem		; scrtomem - copie tout l'cran sauf la dernre ligne de caractres

	moveq	#8,d1			; y deuxime ligne donc 8=hauteur d'un caractre avec cette taille de police
	jsr	graphlib::memtoscr		; memtoscr - recopie l'cran copi plus haut  partir de la deuxime ligne

	move.w	#$E000,d0		; ralentit un peu en effectuant rien du tout $E000 fois

 wait:	

	dbra	d0,wait			; effectue la boucle $E000=57344 fois

	btst	#1,$60001A		; test le bit de [on] et quitte si [on] est appuy
	bne	prc			; sinon goto prc
	rts				; quitte le programme

 nvide1:				; il y a un caractre alors une chance sur 10 pour qu'il n'y en ait plus

	moveq	#10-1,d0		; intervalle: [0,9]

	jsr	userlib::random		; flib::random - retourne un entier pseudo-alatoire
	tst.w	d0			; si random donne 0 alors on enlve le caractre - voir plus bas
	bne	car1			; sinon on continue d'en mettre au label car1

	moveq	#32,d5			; d5 contient le code du caractre  entrer dans la liste si $20 alors aucun

	bra	car3			; va  car3 pour afficher la caractre et entrer la valeur dans la liste

_comment	dc.b	"Ximoon's Matrix Viewer 1.5",0	; ledit commentaire

	bss				; on gagne un peu de place avec un bss
liste	ds.b	char_n			; liste de 40 lments dans laquelle sont stocks les codes des caractres
	end



